<template>
<div :class="classes">
	<div class="floater">
		<div class="title">Create New Lobby</div>
		<component
			v-for="item in items"
			v-on:change="onChange"
			v-on:click="onClick"
			v-on:hover="onHover"
			:key="item.ref"
			:id="item.id"
			:is="item.type"
			:options="item.options"
			:ref="item.ref"
			:selected="selected === item.id"
			:value="item.value"
		>{{ item.text }}</component>
	</div>
</div>
</template>

<script>
import DropdownItem from "../components/DropdownItem.vue"
import InputItem from "../components/InputItem.vue"
import StandardItem from "../components/StandardItem.vue"

import MapOptions from "../../../common/constants/MapOptions.js"
import ModeOptions from "../../../common/constants/ModeOptions.js"
import TeamOptions from "../../../common/constants/TeamOptions.js"

const MAPS = MapOptions.map((opt) => { return opt.name })
const MODES = ModeOptions.map((opt) => { return opt.name })
const TEAMS = TeamOptions.map((opt) => { return opt.name })

export default {
	components: { DropdownItem, InputItem, StandardItem },
	computed: {
		classes () {
			return {
				"create-new-lobby": true
			}
		},
		items () {
			return [{
				id: 0,
				ref: "r0",
				text: "Name",
				type: "input-item",
				value: this.lobby_name
			}, {
				id: 1,
				options: MAPS,
				ref: "r1",
				text: "Map",
				type: "dropdown-item",
				value: this.map
			}, {
				id: 2,
				options: MODES,
				ref: "r2",
				text: "Mode",
				type: "dropdown-item",
				value: this.mode
			}, {
				id: 3,
				options: TEAMS,
				ref: "r3",
				text: "Teams",
				type: "dropdown-item",
				value: this.team
			}, {
				id: 4,
				ref: "r4",
				text: "Create Lobby",
				type: "standard-item"
			}, {
				id: 5,
				ref: "r5",
				text: "Cancel",
				type: "standard-item"
			}]
		}
	},
	created () {
		this.$on("PRESS_BACK", this.pressBack.bind(this))
		this.$on("PRESS_DOWN", this.pressDown.bind(this))
		this.$on("PRESS_ENTER", this.pressEnter.bind(this))
		this.$on("PRESS_UP", this.pressUp.bind(this))
	},
	data: function () {
		return {
			lobby_name: Settings.get("LOBBY_NAME"),
			map: MapOptions.find((map) => {
					return Settings.get("LOBBY_MAP") === map.id
			}).name,
			mode: ModeOptions.find((mode) => {
					return Settings.get("LOBBY_MODE") === mode.id
			}).name,
			selected: 0,
			team: TeamOptions.find((team) => {
				return Settings.get("LOBBY_TEAMS") === team.id
			}).name
		}
	},
	methods: {
		getSelectedItem (id) {
			id = (id || id === 0) ? id : this.selected
			return this.$refs[`r${id}`][0]
		},
		onChange (id, value) {
			switch (id) {
				case 0:
					Settings.set("LOBBY_NAME", value)
					this.lobby_name = value
					break
				case 1:
					this.map = MAPS[value]
					Settings.set("LOBBY_MAP", MapOptions.find((map) => {
						return this.map === map.name
					}).id)
					break
				case 2:
					this.mode = MODES[value]
					Settings.set("LOBBY_MODE", ModeOptions.find((mode) => {
						return this.mode === mode.name
					}).id)
					break
				case 3:
					this.team = TEAMS[value]
					Settings.set("LOBBY_TEAMS", TeamOptions.find((team) => {
						return this.team === team.name
					}).id)
					break
			}
		},
		onClick (id) {
			id = (id || id === 0) ? id : this.selected

			switch (id) {
				case 4:
					this.$emit("create-lobby", {
						map: this.map,
						mode: this.mode,
						name: this.lobby_name,
						teams: this.team
					})
					break
				case 5:
					this.onClose()
					break
			}
		},
		onClose () {
			UI.emit("PLAY_BACK_SOUND")
			this.$emit("close")
		},
		onHover (id) {
			if (this.selected !== id) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected = id
			}
		},
		pressBack () {
			const item = this.getSelectedItem()
			if (item.focused) {
				UI.emit("PLAY_BACK_SOUND")
				item.blur()
			} else {
				this.onClose()
			}
		},
		pressDown () {
			const item = this.getSelectedItem()
			if (item.focused) {
				item.$emit("PRESS_DOWN")
			} else if (this.selected < this.items.length - 1) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected++
			}
		},
		pressEnter () {
			const item = this.getSelectedItem()
			if (!item.focused) {
				item.onClick()
			} else {
				item.$emit("PRESS_ENTER")
			}
		},
		pressUp () {
			const item = this.getSelectedItem()
			if (item.focused) {
				item.$emit("PRESS_UP")
			} else if (this.selected > 0) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected--
			}
		}
	},
	name: "create-new-lobby"
}
</script>

<style lang="less" scoped>
.create-new-lobby {
	align-items: center;
	background: rgba(0, 0, 0, 0.5);
	bottom: 0;
	color: #fff;
	display: flex;
	justify-content: center;
	left: 0;
	position: fixed;
	right: 0;
	top: 0;
	z-index: 10000;
}

.floater {
	background-color: #000;
	border: 1px #fff solid;
	flex-direction: column;
	padding: 2em;
	width: 75em;
}

.title {
	font-size: 6em;
	margin-bottom: .5em;
	text-align: center;
}
</style>
